#
# Filter to create an icon 
# from a VHDL file
#

BEGIN {
	vgi_vhdl2icon_generics="on";  # off = no generic pins will be generated
	vgi_vhdl2icon_small_symbols="on";  # on = use small symol set
      }
      
      
BEGIN \
{
num_gen=0;
num_bid=0;
num_oup=0;
num_inp=0;
target="entity";
}


# parsing the vhdl code

# splitting each line into its components
/./ \
{
string_num=0;
end_line="false";
for(n=1;end_line=="false";n++)
  {
	if (substr($n,1,2)=="--" || $n=="")
	  {
		end_line="true";
	  }
	 else 
	  {
		cluster=$n;
		gsub("[(]"," ( ",cluster);
		gsub("[)]"," ) ",cluster);
		gsub(";"," ; ",cluster);
		gsub(":"," : ",cluster);
		part_num=split(cluster, part, " ");
		for(p=0; p<=part_num;p++)
		 {
		     if (part[p]!="")
		      {
			string[string_num]=part[p];
			string_num++;
		      };
		 };
	  }
  };
string_num--;
#*for(p=0; p<=string_num; p++) {print p "=" string[p]};
}


# parsing through the code
/./ \
{
for(parse_pos=0;parse_pos<=string_num;parse_pos++)
  {
    for(;1;)
    {
	if (target=="entity")
	  {
		if (tolower(string[parse_pos])=="entity")
		  {
			target="entity_name";
		  };
		break;
	  };
	 if (target=="entity_name")
	     {
		entity=string[parse_pos];
		target="port";
		break;
	     };
	 if (target=="port")
	  {
		if (string[parse_pos]=="generic")
		  {
			target="g_port";
		  };
		if (string[parse_pos]=="(")
		  {
			target="sig_name";
		  };
		break;
	  };
	 if (target=="sig_name")
	  {
		target="sig_colon";
		sig_name=string[parse_pos];
		break;
	  };
	 if (target=="sig_colon")
	  {
		target="sig_dir";
		break;
	  };
	 if (target=="sig_dir")
	  {
		target="sig_type";
		sig_dir=string[parse_pos];
		break;
	  };
	 if (target=="sig_type")
	  {
		target="sig_type_end";
		sig_type=string[parse_pos];
		break;
	  };
	 if (target=="sig_type_end")
	    {
		if (string[parse_pos]=="(")
		  {
			target="upper_bound";
			sig_type=sig_type "(";
		  }
		 else
		  {
			if (tolower(sig_dir)=="in")
			  {
				input[num_inp]=sig_name;
				i_type[num_inp]=sig_type;
				num_inp++;
			  };
			if (tolower(sig_dir)=="out")
			  {
				output[num_oup]=sig_name;
				o_type[num_oup]=sig_type;
				num_oup++;
			  };
			if (tolower(sig_dir)=="inout")
			  {
				bidir[num_bid]=sig_name;
				b_type[num_bid]=sig_type;
				num_bid++;
			  };
			target="sig_name";
			if (string[parse_pos]==":") # (init value for signal)
			  {
				target="sig_init";
			  }
			if (string[parse_pos]==")")
			  {
				target="arch";
			  }
		  };
		break;
	     };
	 if (target=="sig_init") {target="sig_init_="; break}
	 if (target=="sig_init_=")
	    {
		if (string[parse_pos]="(")
		   {
			target="sig_init_)";
		   }
		  else
		   {
			if (string[parse_pos]==";") {target="sig_name";}
			if (string[parse_pos]==")") {target="arch";}
		   }
		break;
	    };
	 if (target=="sig_init_)")
	    {
		if (string[parse_pos]=")")
			target="sig_init_=";
		break;
	    };
	 if (target=="upper_bound")
	    {
		target="vec_dir";
		sig_type=sig_type string[parse_pos];
		break;
	    };
	 if (target=="vec_dir")
	   {
		target="lower_bound";
		sig_type=sig_type " " string[parse_pos] " ";
		break;
	   };
	 if (target=="lower_bound")
	  {
		target="vec_end";
		sig_type=sig_type string[parse_pos] ")";
		break;
	  };
	 if (target=="vec_end")
	  {
		target="sig_type_end";
		break;
	  };
	 if (target=="g_port")
	  {
		if (string[parse_pos]=="(")
		  {
			target="gen_name";
		  };
		break;
	  };
	 if (target=="gen_name")
	  {
		target="gen_colon";
		gen_name=string[parse_pos];
		break;
	  };
	 if (target=="gen_colon")
	  {
		target="gen_type";
		break;
	  };
	 if (target=="gen_type")
	  {
		target="gen_type_end";
		gen_type=string[parse_pos];
		break;
	  };
	 if (target=="gen_type_end")
	    {
		if (string[parse_pos]=="(")
		  {
			target="g_upper_bound";
			gen_type=gen_type "(";
		  }
		 else
		  {
			generic[num_gen]=gen_name;
			g_type[num_gen]=gen_type;
			g_init[num_gen]="";
			num_gen++;
			target="gen_name";
			if (string[parse_pos]==")")
			  {
				target="port";
			  };
			if (string[parse_pos]==":")
			  {
				target="g_=";
			  };
		  };
		break;
	     };
	 if (target=="g_=")
	    {
		target="gen_init";
		break;
	    };
	 if (target=="gen_init")
	    {
		g_init[num_gen-1]=string[parse_pos];
		#*print "#### init = " g_init[num_gen-1]; 
		gsub("[\"]", "\\\"", g_init[num_gen-1]); 
			# -> substitute `"' with `\"'
		target="gen_end";
		break;
	    };
	 if (target=="gen_end")
	    {
		if (string[parse_pos]==";")
		  {
			target="gen_name";
		  };
		if (string[parse_pos]==")")
		  {
			target="port";
		  };
		break;
	    };
	 if (target=="g_upper_bound")
	    {
		target="g_vec_dir";
		gen_type=gen_type string[parse_pos];
		break;
	    };
	 if (target=="g_vec_dir")
	   {
		target="g_lower_bound";
		gen_type=gen_type " " string[parse_pos] " ";
		break;
	   };
	 if (target=="g_lower_bound")
	  {
		target="g_vec_end";
		gen_type=gen_type string[parse_pos] ")";
		break;
	  };
	 if (target=="g_vec_end")
	  {
		target="gen_type_end";
		break;
	  };
	 if (target=="arch")
	  {
		if (tolower(string[parse_pos])=="architecture")
		  {
			target="arch_name";
		  };
		break;
	  };
	 if (target=="arch_name")
	     {
		arch=string[parse_pos];
		target="none";
		break;
	     };
	 if (target=="none")
	     {
		break;
	     };
    };
  };
};



# File Header
BEGIN \
{
print "%TGIF 2.15-p3";
print "state(0,31,100,50,0,0,16,1,3,3,1,0,0,0,0,1,0,'Courier',0,10,0,0,1,5,0,0,1,1,0,16,0,0,1,1,1,0).";
print "%";
print "% @(#)$Header$";
print "% %W%";
print "%";
print "page(1,\"\").";
}


#--* # generating the sym file
#--* 
#--* END	{if (vgi_vhdl2icon_generics=="off") num_gen=0; }
#--* 
#--* # entity
#--* #
#--* END	{
#--* l1=15+num_gen*45+num_inp*30; #finding length of entity box
#--* l2=15+num_bid*30+num_oup*30;
#--* e_length=l1;
#--* if (l2>l1) e_length=l2;
#--* print "sym([";
#--* print "group([";
#--* print "text('white',370,50,'Courier',0,8,1,0,0,1,30,10,14990,0,8,2,2,0,0,0,[";
#--* print "\t\"###ENT\"]),";
#--* print "box('black',300,50,450," e_length+120 ",2,2,1,1529,0,0,0,["; # 300
#--* print "]),";
#--* print "text('black',310,50,'Courier',0,10,1,0,0,0,48,11,6554,0,9,2,0,0,0,0,[";
#--* print "\t\"launch=x\"])";
#--* print "],";
#--* print "15002,0,[";
#--* print "attr(\"entity=\", \"" entity "\", 1, 1, 0,";
#--* print "text('black',310,78,'Courier',0,10,1,0,0,1,108,11,1954,0,9,2,0,0,0,0,[";
#--* print "\t\"entity=" entity "\"])),";
#--* print "attr(\"arch=\", \"" arch "\", 1, 1, 0,";
#--* print "text('black',310,134,'Courier',0,10,1,0,0,1,90,11,5306,0,9,2,0,0,0,0,[";
#--* print "\t\"arch=" arch "\"]))";
#--* print "]),";
#--* }
#--* 
#--*  
#--* #
#--* # generic pin
#--* #
#--* END {
#--*  for(n=0; n<num_gen;n++)
#--*    {
#--* 	print "group([";
#--* 	print "text('white',260," 80+n*45 \
#--* 	      ",'Courier',0,8,1,0,0,1,30,10,4673,0,8,2,0,0,0,0,[";
#--* 	print "\t\"###GEN\"]),";
#--* 	print "text('black',250," 60+n*45 \
#--* 	      ",'Courier',0,10,1,2,0,1,102,11,4675,0,9,2,0,0,0,0,[";
#--* 	print "\t\"generic=" generic[n] "\"]),";
#--* 	print "text('black',250," 75+n*45 \
#--* 	      ",'Courier',0,10,1,2,0,1,72,11,4676,0,9,2,0,0,0,0,[";
#--* 	print "\t\"type=" g_type[n] "\"]),";
#--* 	print "poly('black',6,[";
#--* 	print "	260," 70+n*45 \
#--* 	      ",265," 70+n*45 \
#--* 	      ",280," 85+n*45 \
#--* 	      ",265," 100+n*45 \
#--* 	      ",260," 100+n*45 \
#--* 	      ",260," 70+n*45 \
#--* 	      "],0,2,1,4674,0,7,0,0,10,4,0,";
#--* 	print "    \"00\",[";
#--* 	print "]),";
#--* 	print "poly('black',2,[";
#--* 	print "	280," 85+n*45 \
#--* 	      ",300," 85+n*45 \
#--* 	      "],0,2,1,4677,0,0,0,0,10,4,0,";
#--* 	print "    \"0\",[";
#--* 	print "]),";
#--* 	print "text('black',250," 90+n*45 \
#--* 	      ",'Courier',0,10,1,2,0,1,42,11,4697,0,9,2,0,0,0,0,[";
#--* 	print "\t\"init=" g_init[n] "\"])";
#--* 	#*print "####init= " g_init[n];
#--* 	print "],";
#--* 	print "15721,0,[";
#--* 	print "]),";
#--*     }
#--* }
#--* 
#--* 
#--* # 
#--* # bidir pin
#--* #
#--* END { \
#--* for(n=0; n<num_bid;n++)
#--*  {
#--* 	print "group([";
#--* 	print "text('white',530," 85+n*30 \
#--* 	      ",'Courier',0,8,1,0,2,1,30,10,16705,0,8,2,0,0,0,0,[";
#--* 	print "\t\"###BID\"]),";
#--* 	print "text('black',555," 65+n*30 \
#--* 	      ",'Courier',0,10,1,0,0,1,72,11,16706,0,9,2,0,0,0,0,[";
#--* 	print "\t\"inout=" bidir[n] "\"]),";
#--* 	print "text('black',555," 80+n*30 \
#--* 	      ",'Courier',0,10,1,0,0,1,246,11,16707,0,9,2,0,0,0,0,[";
#--* 	print "\t\"type=" b_type[n] "\"]),";
#--* 	print "poly('black',7,[";
#--* 	print "	480," 80+n*30 \
#--* 	      ",495," 65+n*30 \
#--* 	      ",530," 65+n*30 \
#--* 	      ",545," 80+n*30 \
#--* 	      ",530," 95+n*30 \
#--* 	      ",495," 95+n*30 \
#--* 	      ",480," 80+n*30 \
#--* 	      "],0,2,1,16708,0,7,0,0,10,4,0,";
#--* 	print "    \"00\",[";
#--* 	print "]),";
#--* 	print "poly('black',2,[";
#--* 	print "\t480," 80+n*30 \
#--* 	      ",450," 80+n*30 \
#--* 	      "],0,2,1,16709,0,0,0,0,10,4,0,";
#--* 	print "    \"0\",[";
#--* 	print "])";
#--* 	print "],";
#--* 	print "16704,0,[";
#--* 	print "]),";
#--*   } \
#--* }
#--* 
#--* 
#--*  
#--* # 
#--* # output pin
#--* #
#--* END { \
#--* for(n=0; n<num_oup;n++)
#--*  {
#--* 	print "group([";
#--* 	print "text('white',510," 100+(n+num_bid)*30 \
#--* 	      ",'Courier',0,8,1,0,2,1,30,10,3507,0,8,2,0,0,0,0,[";
#--* 	print "\t\"###OUP\"]),";
#--* 	print "text('black',530," 80+(n+num_bid)*30 \
#--* 	      ",'Courier',0,10,1,0,0,1,84,11,3509,0,9,2,0,0,0,0,[";
#--* 	print "\t\"output=" output[n] "\"]),";
#--* 	print "text('black',530," 95+(n+num_bid)*30 \
#--* 	      ",'Courier',0,10,1,0,0,1,60,11,3510,0,9,2,0,0,0,0,[";
#--* 	print "\t\"type=" o_type[n] "\"]),";
#--* 	print "poly('black',6,[";
#--* 	print "	470," 80+(n+num_bid)*30 \
#--* 	      ",505," 80+(n+num_bid)*30 \
#--* 	      ",520," 95+(n+num_bid)*30 \
#--* 	      ",505," 110+(n+num_bid)*30 \
#--* 	      ",470," 110+(n+num_bid)*30 \
#--* 	      ",470," 80+(n+num_bid)*30 \
#--* 	      "],0,2,1,3508,0,7,0,0,10,4,0,";
#--* 	print "    \"00\",[";
#--* 	print "]),";
#--* 	print "poly('black',2,[";
#--* 	print "	470," 95+(n+num_bid)*30 \
#--* 	      ",450," 95+(n+num_bid)*30 \
#--* 	      "],0,2,1,3511,0,0,0,0,10,4,0,";
#--* 	print "    \"0\",[";
#--* 	print "])";
#--* 	print "],";
#--* 	print "16704,0,[";
#--* 	print "]),";
#--*   } \
#--* }
#--* 
#--* 
#--* #
#--* # input pin
#--* # 
#--* END { \
#--* for(n=0; n<num_inp;n++)
#--*  {
#--* 	print "group([";
#--* 	print "text('white',240," 85+n*30+num_gen*45 \
#--* 	      ",'Courier',0,8,1,0,0,1,30,10,2235,0,8,2,0,0,0,0,[";
#--* 	print "\t\"###INP\"]),";
#--* 	print "text('black',220," 75+n*30+num_gen*45 \
#--* 	      ",'Courier',0,10,1,2,0,1,54,11,1695,0,9,2,0,0,0,0,[";
#--* 	print "\t\"input=" input[n] "\"]),";
#--* 	print "text('black',220," 90+n*30+num_gen*45 \
#--* 	      ",'Courier',0,10,1,2,0,1,48,11,1699,0,9,2,0,0,0,0,[";
#--* 	print "\t\"type=" i_type[n] "\"]),";
#--* 	print "poly('black',6,[";
#--* 	print "	230," 75+n*30+num_gen*45 \
#--* 	      ",265," 75+n*30+num_gen*45 \
#--* 	      ",280," 90+n*30+num_gen*45 \
#--* 	      ",265," 105+n*30+num_gen*45 \
#--* 	      ",230," 105+n*30+num_gen*45 \
#--* 	      ",230," 75+n*30+num_gen*45 \
#--* 	      "],0,2,1,1674,0,7,0,0,10,4,0,";
#--* 	print "    \"00\",[";
#--* 	print "]),";
#--* 	print "poly('black',2,[";
#--* 	print "	280," 90+n*30+num_gen*45 \
#--* 	      ",300," 90+n*30+num_gen*45 \
#--* 	      "],0,2,1,2074,0,0,0,0,10,4,0,";
#--* 	print "    \"0\",[";
#--* 	print "])";
#--* 	print "],";
#--* 	print "2250,0,[";
#--* 	print "]),";
#--*   } \
#--* }
#--* 
#--* # icon end
#--* #
#--* END	{print "],"}
#--* END	{print "17735,0,["}
#--* END	{print "])."}
#--* 




# generating the sym file with small blocks

END	{if (vgi_vhdl2icon_generics=="off") num_gen=0; }

# entity
#
END	{
l1=15+num_gen*30+num_inp*20; #finding length of entity box
l2=15+num_bid*20+num_oup*20;
e_length=l1;
if (l2>l1) e_length=l2;
print "sym([";
print "group([";
print "text('white',370,50,'Courier',0,8,1,0,0,1,30,10,14990,0,8,2,2,0,0,0,[";
print "\t\"###ENT\"]),";
print "box('black',300,50,425," e_length+80 ",2,2,1,1529,0,0,0,["; # 300
print "]),";
print "text('black',310,50,'Courier',0,10,1,0,0,0,48,11,6554,0,9,2,0,0,0,0,[";
print "\t\"launch=x\"])";
print "],";
print "15002,0,[";
print "attr(\"entity=\", \"" entity "\", 1, 1, 0,";
print "text('black',310,78,'Courier',0,10,1,0,0,1,108,11,1954,0,9,2,0,0,0,0,[";
print "\t\"entity=" entity "\"])),";
print "attr(\"arch=\", \"" arch "\", 1, 1, 0,";
print "text('black',310,134,'Courier',0,10,1,0,0,1,90,11,5306,0,9,2,0,0,0,0,[";
print "\t\"arch=" arch "\"]))";
print "]),";
}

 
#
# generic pin
#
END {
 for(n=0; n<num_gen;n++)
   {
	print "group([";
	print "text('white',265," 80+n*30 \
	      ",'Courier',0,8,1,0,0,1,30,10,4673,0,8,2,0,0,0,0,[";
	print "\t\"###GEN\"]),";
	print "text('black',265," 65+n*30 \
	      ",'Courier',0,8,1,2,0,1,102,11,4675,0,9,2,0,0,0,0,[";
	print "\t\"generic=" generic[n] "\"]),";
	print "text('black',265," 75+n*30 \
	      ",'Courier',0,8,1,2,0,1,72,11,4676,0,9,2,0,0,0,0,[";
	print "\t\"type=" g_type[n] "\"]),";
	print "poly('black',6,[";
	print "	270," 75+n*30 \
	      ",275," 75+n*30 \
	      ",285," 85+n*30 \
	      ",275," 95+n*30 \
	      ",270," 95+n*30 \
	      ",270," 75+n*30 \
	      "],0,1,1,4674,0,7,0,0,10,4,0,";
	print "    \"00\",[";
	print "]),";
	print "poly('black',2,[";
	print "	285," 85+n*30 \
	      ",300," 85+n*30 \
	      "],0,1,1,4677,0,0,0,0,10,4,0,";
	print "    \"0\",[";
	print "]),";
	print "text('black',266," 85+n*30 \
	      ",'Courier',0,8,1,2,0,1,42,11,4697,0,9,2,0,0,0,0,[";
	print "\t\"init=" g_init[n] "\"])";
	#*print "####init= " g_init[n];
	print "],";
	print "15721,0,[";
	print "]),";
    }
}


# 
# bidir pin
#
END { \
for(n=0; n<num_bid;n++)
 {
	print "group([";
	print "text('white',465," 80+n*20 \
	      ",'Courier',0,8,1,0,2,1,30,10,16705,0,8,2,0,0,0,0,[";
	print "\t\"###BID\"]),";
	print "text('black',490," 65+n*20 \
	      ",'Courier',0,8,1,0,0,1,72,11,16706,0,9,2,0,0,0,0,[";
	print "\t\"inout=" bidir[n] "\"]),";
	print "text('black',490," 75+n*20 \
	      ",'Courier',0,8,1,0,0,1,246,11,16707,0,9,2,0,0,0,0,[";
	print "\t\"type=" b_type[n] "\"]),";
	print "poly('black',7,[";
	print "	440," 75+n*20 \
	      ",450," 65+n*20 \
	      ",470," 65+n*20 \
	      ",480," 75+n*20 \
	      ",470," 85+n*20 \
	      ",450," 85+n*20 \
	      ",440," 75+n*20 \
	      "],0,1,1,16708,0,7,0,0,10,4,0,";
	print "    \"00\",[";
	print "]),";
	print "poly('black',2,[";
	print "\t440," 75+n*20 \
	      ",425," 75+n*20 \
	      "],0,1,1,16709,0,0,0,0,10,4,0,";
	print "    \"0\",[";
	print "])";
	print "],";
	print "16704,0,[";
	print "]),";
  } \
}


 
# 
# output pin
#
END { \
for(n=0; n<num_oup;n++)
 {
	print "group([";
	print "text('white',470," 95+(n+num_bid)*20 \
	      ",'Courier',0,8,1,0,2,1,30,10,3507,0,8,2,0,0,0,0,[";
	print "\t\"###OUP\"]),";
	print "text('black',485," 80+(n+num_bid)*20 \
	      ",'Courier',0,8,1,0,0,1,84,11,3509,0,9,2,0,0,0,0,[";
	print "\t\"output=" output[n] "\"]),";
	print "text('black',485," 90+(n+num_bid)*20 \
	      ",'Courier',0,8,1,0,0,1,60,11,3510,0,9,2,0,0,0,0,[";
	print "\t\"type=" o_type[n] "\"]),";
	print "poly('black',6,[";
	print "	440," 80+(n+num_bid)*20 \
	      ",465," 80+(n+num_bid)*20 \
	      ",475," 90+(n+num_bid)*20 \
	      ",465," 100+(n+num_bid)*20 \
	      ",440," 100+(n+num_bid)*20 \
	      ",440," 80+(n+num_bid)*20 \
	      "],0,1,1,3508,0,7,0,0,10,4,0,";
	print "    \"00\",[";
	print "]),";
	print "poly('black',2,[";
	print "	440," 90+(n+num_bid)*20 \
	      ",425," 90+(n+num_bid)*20 \
	      "],0,1,1,3511,0,0,0,0,10,4,0,";
	print "    \"0\",[";
	print "])";
	print "],";
	print "16704,0,[";
	print "]),";
  } \
}


#
# input pin
# 
END { \
for(n=0; n<num_inp;n++)
 {
	print "group([";
	print "text('white',250," 80+n*20+num_gen*30 \
	      ",'Courier',0,8,1,0,0,1,30,10,2235,0,8,2,0,0,0,0,[";
	print "\t\"###INP\"]),";
	print "text('black',245," 75+n*20+num_gen*30 \
	      ",'Courier',0,8,1,2,0,1,54,11,1695,0,9,2,0,0,0,0,[";
	print "\t\"input=" input[n] "\"]),";
	print "text('black',245," 85+n*20+num_gen*30 \
	      ",'Courier',0,8,1,2,0,1,48,11,1699,0,9,2,0,0,0,0,[";
	print "\t\"type=" i_type[n] "\"]),";
	print "poly('black',6,[";
	print "	250," 75+n*20+num_gen*30 \
	      ",275," 75+n*20+num_gen*30 \
	      ",285," 85+n*20+num_gen*30 \
	      ",275," 95+n*20+num_gen*30 \
	      ",250," 95+n*20+num_gen*30 \
	      ",250," 75+n*20+num_gen*30 \
	      "],0,1,1,1674,0,7,0,0,10,4,0,";
	print "    \"00\",[";
	print "]),";
	print "poly('black',2,[";
	print "	285," 85+n*20+num_gen*30 \
	      ",300," 85+n*20+num_gen*30 \
	      "],0,1,1,2074,0,0,0,0,10,4,0,";
	print "    \"0\",[";
	print "])";
	print "],";
	print "2250,0,[";
	print "]),";
  } \
}

# icon end
#
END	{print "],"}
END	{print "17735,0,["}
END	{print "])."}
